package btools.router.navi;

import rgnavigator.core.interfaces.NaviNodeI;
import rgnavigator.core.interfaces.NodeAttributeContainerI;
import rgnavigator.core.interfaces.PosI;
import btools.mapaccess.OsmPos;
import btools.mapaccess.OsmTransferNode;

public class NaviTrackElement implements NaviNodeI {
	private int ilat; // latitude
	private int ilon; // longitude
	private short selev; // longitude
	private NodeAttributeContainerI nodeAttributeContainer;


	public NaviTrackElement(OsmPos pPos) {
		this(pPos, null);
	}
		
	public NaviTrackElement(OsmPos pPos,  NodeAttributeContainerI pNodeAttributeContainer) {
		ilon = pPos.getILon();
		ilat = pPos.getILat();
		selev = pPos.getSElev();
		nodeAttributeContainer = pNodeAttributeContainer;
	}

//	public NaviTrackElement(OsmPos pNode, int pDist) {
//		this(pNode);
//		distance = pDist;
//	}

	public NaviTrackElement(OsmTransferNode pNode, NodeAttributeContainerI pNodeAttributeContainer) {
		ilon = pNode.ilon;
		ilat = pNode.ilat;
		selev = pNode.selev;
		nodeAttributeContainer = pNodeAttributeContainer;
	}

	// ==========================================================
	public void set(PosI pPos) {
		ilon = pPos.getILon();
		ilat = pPos.getILat();
		selev = pPos.getSElev();
	}

	// interface OsmPos
	public int getILat() {
		return ilat;
	}

	public int getILon() {
		return ilon;
	}

	public short getSElev() {
		return selev;
	}

//	public long getIdFromPos() {
//		return NaviUtil.getIdFromPos(ilon, ilat);
//	}

//	public int calcDistance(OsmPos p) {
//		return NaviUtil.calcDistance(ilon, ilat, p);
//	}

	public String toString() {
		return ilon + "_" + ilat;
	}

	@Override
	public double getElev() {
		return selev / 4.;
	}

//	@Override
//	public int getDistance() {
//		return distance;
//	}

//	public void setDistance(int pDist) {
//		distance = pDist;
//	}

//	@Override
//	public boolean equals(NaviTrackElementI cmp) {
//		return getIdFromPos() == cmp.getIdFromPos() && getSElev() == cmp.getSElev() && getDistance() == cmp.getDistance();
//	}

	@Override
	public int compare(PosI cmp) {
		int result = getILon() - cmp.getILon();
		if (result == 0) {
			result = getILat() - cmp.getILat();
		}
		return result;
	}

	@Override
	public boolean equals(Object pPos) {
		boolean result = false;
		if (pPos instanceof PosI)
			result = compare((PosI) pPos) == 0;
		return result;
	}

	@Override
	public NodeAttributeContainerI getNodeAttributeContainer() {
		return nodeAttributeContainer;
	}
	
	
}
