package rgnavigator.core;

import rgnavigator.core.exceptions.CloneNotSupportedRuntimeException;
import rgnavigator.core.interfaces.PosI;

public class Pos implements PosI {

	/**
	 * The latitude
	 */
	private int ilat;

	/**
	 * The longitude
	 */
	private int ilon;

	/**
	 * The elevation
	 */
	private short selev;

	public Pos() {

	}

	// ==========================================================
	public Pos(int pIlon, int pIlat, short pSelev) {
		ilon = pIlon;
		ilat = pIlat;
		selev = pSelev;
	}

	// ==========================================================
	public Pos(PosI pPos) {
		this(pPos.getILon(), pPos.getILat(), pPos.getSElev());
	}

	// ==========================================================
	public void set(PosI pPos) {
		ilon = pPos.getILon();
		ilat = pPos.getILat();
		selev = pPos.getSElev();
	}

	// ==========================================================
	public int getILat() {
		return ilat;
	}

	// ==========================================================
	public int getILon() {
		return ilon;
	}

	// ==========================================================
	public short getSElev() {
		return selev;
	}

	// ==========================================================
	public double getElev() {
		return selev / 4.;
	}

	// ==========================================================
	public void setILat(int ilat) {
		this.ilat = ilat;
	}

	// ==========================================================
	public void setILon(int ilon) {
		this.ilon = ilon;
	}

	// ==========================================================
	public void setSElev(short selev) {
		this.selev = selev;
	}

	// ==========================================================

	@Override
	public Object clone() {
		try {
			return super.clone();
		} catch (CloneNotSupportedException e) {
			throw new CloneNotSupportedRuntimeException(e);
		}
	}

	// ==========================================================

	public int compare(PosI cmp) {
		int result = getILon() - cmp.getILon();
		if (result == 0) {
			result = getILat() - cmp.getILat();
		}
		return result;
	}

	// ==========================================================

	@Override
	public boolean equals(Object pPos) {
		boolean result = false;
		if (pPos instanceof PosI)
			result = compare((PosI) pPos) == 0;
		return result;
	}

	// ==========================================================

	public String toString() {
		return "lon = " + ilon + " lat = " + ilat;
	}
}
