package rgnavigator.core;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

import rgnavigator.core.interfaces.PosI;
import rgnavigator.core.interfaces.WayConnectorI;
import rgnavigator.core.interfaces.WayNodeI;

public class WayConnector extends Pos implements WayConnectorI {
	private List<WayNodeI> wayNodes = new ArrayList<WayNodeI>();
	private List<WayNodeI> neighbours = new ArrayList<WayNodeI>();

	// ==========================================================
	public WayConnector(PosI pPos) {
		super(pPos);
	}

	// ==========================================================
	@Override
	public Collection<WayNodeI> getWayNodes() {
		return wayNodes;
	}
	
	// ==========================================================
	@Override
	public Collection<WayNodeI> getNeighbourWayNodes() {
		return neighbours;
	}

	// ==========================================================
	@Override
	public void addWayNode(WayNodeI pNode) {
		wayNodes.add(pNode);
		neighbours.addAll(pNode.getNeighbours());
	}

	// ==========================================================

	public boolean contains(WayNodeI pNode) {
		boolean result = false;
		for (WayNodeI check : wayNodes) {
			if (check.equals(pNode)) {
				result = true;
				break;
			}
		}
		return result;
	}

	// ==========================================================	
	public boolean equals(Object cmp) {
		boolean result = false;

		if (cmp instanceof WayConnectorI) {
			result = this == cmp;
		} 
		return result;
	}
	// ==========================================================

	@Override
	public WayConnectorI clone() {
		return (WayConnectorI) super.clone();
	}

}
