package rgnavigator.core;

import java.util.List;

import rgnavigator.core.interfaces.WayIteratorI;
import rgnavigator.core.interfaces.WayNodeI;

public class WayIterator implements WayIteratorI {
	private List<WayNodeI> wayNodes;
	private int index;
	private int stepValue;
	private int endIndex;

	// ==========================================================
	/**
	 * Get all waypoints between start and end position without the start and
	 * end
	 * 
	 * @param pWayNodes
	 * @param reverse
	 */

	public WayIterator(List<WayNodeI> pWayNodes, boolean reverse) {
		wayNodes = pWayNodes;
		if (reverse) {
			index = wayNodes.size() - 2;
			stepValue = -1;
			endIndex = 1;
		} else {
			index = 1;
			stepValue = 1;
			endIndex = wayNodes.size() - 2;
		}
	}

	// ==========================================================

	@Override
	public boolean hasNext() {
		boolean result = false;
		if (stepValue > 0) {
			result = index <= endIndex;
		} else {
			result = index >= endIndex;

		}
		return result;
	}

	// ==========================================================

	@Override
	public WayNodeI next() {
		WayNodeI result = null;
		if (hasNext()) {
			result = wayNodes.get(index);
			index += stepValue;
		}
		return result;
	}

}
