package rgnavigator.core.factories;

import java.util.List;

import rgnavigator.core.Way;
import rgnavigator.core.WayConnector;
import rgnavigator.core.WayNode;
import rgnavigator.core.interfaces.NaviNodeI;
import rgnavigator.core.interfaces.NodeAttributeContainerI;
import rgnavigator.core.interfaces.PosI;
import rgnavigator.core.interfaces.WayConnectorI;
import rgnavigator.core.interfaces.WayI;
import rgnavigator.core.interfaces.WayNodeI;

public class WayFactory {
	// ==========================================================
	/**
	 * Create a new way. The start and end position have to be included in the list
	 * @param pWayNodes
	 * @return
	 */
	public static final WayI createWay(List<NaviNodeI> pWayNodes) {
		return new Way(pWayNodes);
	}
	
	// ==========================================================

	public static final WayNodeI createWayNode(PosI pPos,  NodeAttributeContainerI pNodeAttributeContainer, WayI pWay) {
		return new WayNode(pPos, pNodeAttributeContainer, pWay);
	}

	// ==========================================================

	public static final WayConnectorI createWayConnector(PosI pPos) {
		return new WayConnector(pPos);
	}
}
