package rgnavigator.scripting;

import java.io.IOException;

import rgnavigator.core.interfaces.NaviWaypointI;
import sisc.data.Value;
import sisc.io.ValueWriter;

public class NaviWaypointValue extends Value {
	private NaviWaypointI waypoint;

	public NaviWaypointValue(NaviWaypointI pPos) {
		waypoint = pPos;
	}

	public NaviWaypointI getWaypoint() {
		return waypoint;
	}
	
	public void setValue(String pAttribName, String pValue) {
		waypoint.setValue(pAttribName, pValue);
	}

	// =======================================================

	public String getValue(String pAttribName) {
		return waypoint.getValue(pAttribName);
	}

	// =======================================================
	@Override
	public void display(ValueWriter pValueWriter) throws IOException {
		pValueWriter.append(waypoint.toString());
	}

}
